首页 > 代码库 > [LeetCode] Distinct Subsequences(DP)

[LeetCode] Distinct Subsequences(DP)

Given a string S and a string T, count the number of distinct subsequences of T in S.

A subsequence of a string is a new string which is formed from the original string by deleting some (can be none) of the characters without disturbing the relative positions of the remaining characters. (ie, "ACE" is a subsequence of "ABCDE" while "AEC" is not).

Here is an example: S = "rabbbit", T = "rabbit"

Return 3.

以下是LeetCode Discuss中非常好的解决方法, using O(mn) space and running in O(mn) time

class Solution {public:    int numDistinct(string S, string T) {    int m = T.length();    int n = S.length();    if (m > n) return 0;    // impossible for subsequence    vector<vector<int>> path(m+1, vector<int>(n+1, 0));    for (int k = 0; k <= n; k++) path[0][k] = 1;    // initialization    for (int j = 1; j <= n; j++) {        for (int i = 1; i <= m; i++) {            path[i][j] = path[i][j-1] + (T[i-1] == S[j-1] ? path[i-1][j-1] : 0);        }    }    return path[m][n];}};

其中 :each cell in matrix Path[i][j] means the number of distinct subsequences of  T.substr(1...i) in S(1...j)。

/**
* Further optimization could be made that we can use only 1D array instead of a
* matrix, since we only need data from last time step.
*/

Updated solution now takes O(n) space

int numDistinct(string S, string T) {    int m = T.length();    int n = S.length();    if (m > n) return 0;    // impossible for subsequence    vector<int> path(m+1, 0);    path[0] = 1;            // initial condition    for (int j = 1; j <= n; j++) {        // traversing backwards so we are using path[i-1] from last time step        for (int i = m; i >= 1; i--) {              path[i] = path[i] + (T[i-1] == S[j-1] ? path[i-1] : 0);        }    }    return path[m];}